<?php
/*  
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
		
	You may also view the license here:
	http://www.gnu.org/licenses/gpl.html#SEC1
*/
include_once('../../../wp-config.php');

if ( !defined('ABSPATH') ) // memberlock_api.php could be in plugins/ or plugins/memberlock/
	include_once('../../wp-config.php');
	
include_once(ABSPATH . 'wp-admin/includes/admin.php');
include_once(ABSPATH . 'wp-admin/includes/user.php');
include_once(ABSPATH . 'wp-includes/functions.php');

$f = $_REQUEST;
$memberlock_security_code = get_option('memberlock_security_code');

if ($memberlock_security_code != '' && $memberlock_security_code != $f['security_code']) {
	die("Incoming Security Code '".$f['security_code']."' does not match the Security Code on file");
}

$f['u_username'] = ($f['u_username'] != '') ? $f['u_username'] : $f['u_email'];

$query = "SELECT user_id FROM ".$wpdb->usermeta." WHERE meta_key='external_user_id' AND meta_value=".(int)$f['id'];
$id_exists = $wpdb->get_row($query);
if ($id_exists->user_id) { // this should take in 99% of cases
	$exists = $wpdb->get_row("SELECT * FROM ".$wpdb->users." WHERE ID=".(int)$id_exists->user_id);
} else { // if someone's WP is messed up then we do this as a fallback, OR if someone upgrades using the membership grouping feature
	$exists = $wpdb->get_row("SELECT * FROM ".$wpdb->users." WHERE user_login='".mres($f['u_username'])."'");
}
$user_ID = $exists->ID;


if ($user_ID) {
	if ($f['mode'] == 'add') {
		$f['mode'] = 'modify'; // if the user exists already, then we should update the record instead of inserting
		$make_active = true; // make sure the account is active since their old WP account may have just been suspended and now we need to upgrade
	}
} else {
	switch ($f['mode']) {
		case 'add':
		case 'reactivate':
		case 'modify':
			$f['mode'] = 'add'; // add the user since they don't exist already
			break;
		case 'suspend':
		case 'delete':
		default:
			die("User could not be found"); // don't add people if they aren't supposed to be valid
			break;
	}
}

$user_array = array( 
	// updating the username every time and using usernames in Nanacast.com is the best way to keep usernames in sync and unique
	'user_login' 	=> $f['u_username'], 
	'user_nicename' => $f['u_username'],
	'user_email' 	=> $f['u_email'],
	'user_url' 		=> $f['u_website'],
	'display_name' 	=> $f['u_firstname'].' '.$f['u_lastname'],
);	

if ($f['u_password'] != '') { // password has changed in remote system
	$user_array['user_pass'] = md5($f['u_password']);
} elseif (!$user_ID || $exists->user_pass == '') {
	// only create a new password if there isn't one or we're adding a new account
	// this is really impractical to the user because there is no way for them to know it unless they request it be sent to them,
	// but we just don't want any blank passwords
	$user_array['user_pass'] = make_password(); 
}

switch ($f['mode']) {
	case 'add':
		// there is one way I can think of where you could get a duplicate username:
		// If you don't use the username field in Nanacast.com (which checks for uniqueness in Nanacast.com) and instead
		// use the email field (which WP will take as the username) and someone uses the same email twice.  
		// the solution: use the username field 
		$wpdb->insert($wpdb->users, $user_array);		
		$user_ID = $wpdb->insert_id;
		update_usermeta( $user_ID, 'first_name', $f['u_firstname']);
		update_usermeta( $user_ID, 'nickname', $f['u_firstname']);
		update_usermeta( $user_ID, 'last_name', $f['u_lastname']);
		update_usermeta( $user_ID, 'external_user_id', $f['id']);
		update_usermeta( $user_ID, 'memberlock_status', 'active');
		update_usermeta( $user_ID, 'memberlock_feedurl', $f['feedurl']);
		update_usermeta( $user_ID, 'memberlock_membership_name', $f['item_name']);
		update_usermeta( $user_ID, 'memberlock_membership_id', $f['u_list_id']);
		$user = new WP_User( $user_ID );
		$user->set_role('subscriber');	
		break;
	case 'reactivate':
		$wpdb->update($wpdb->users, $user_array,array('ID'=>(int)$user_ID));
		update_usermeta( $user_ID, 'first_name', $f['u_firstname']);
		update_usermeta( $user_ID, 'nickname', $f['u_firstname']);
		update_usermeta( $user_ID, 'last_name', $f['u_lastname']);
		update_usermeta( $user_ID, 'external_user_id', $f['id']); // reset this in case it hasn't been set before
		update_usermeta( $user_ID, 'memberlock_status', 'active');
		update_usermeta( $user_ID, 'memberlock_feedurl', $f['feedurl']);
		update_usermeta( $user_ID, 'memberlock_membership_name', $f['item_name']);
		update_usermeta( $user_ID, 'memberlock_membership_id', $f['u_list_id']);
		break;
	case 'modify':
		$wpdb->update($wpdb->users, $user_array,array('ID'=>(int)$user_ID));		
		update_usermeta( $user_ID, 'first_name', $f['u_firstname']);
		update_usermeta( $user_ID, 'nickname', $f['u_firstname']);
		update_usermeta( $user_ID, 'last_name', $f['u_lastname']);
		update_usermeta( $user_ID, 'external_user_id', $f['id']); // reset this in case it hasn't been set before
		if ($make_active) update_usermeta( $user_ID, 'memberlock_status', 'active');
		update_usermeta( $user_ID, 'memberlock_feedurl', $f['feedurl']);
		update_usermeta( $user_ID, 'memberlock_membership_name', $f['item_name']);
		update_usermeta( $user_ID, 'memberlock_membership_id', $f['u_list_id']);
		break;
	case 'suspend':
		$wpdb->update($wpdb->users, $user_array,array('ID'=>(int)$user_ID));		
		update_usermeta( $user_ID, 'first_name', $f['u_firstname']);
		update_usermeta( $user_ID, 'nickname', $f['u_firstname']);
		update_usermeta( $user_ID, 'last_name', $f['u_lastname']);
		update_usermeta( $user_ID, 'memberlock_status', 'suspended');
		update_usermeta( $user_ID, 'external_user_id', $f['id']); // reset this in case it hasn't been set before
		update_usermeta( $user_ID, 'memberlock_feedurl', $f['feedurl']);
		update_usermeta( $user_ID, 'memberlock_membership_name', $f['item_name']);
		update_usermeta( $user_ID, 'memberlock_membership_id', $f['u_list_id']);
		break;
	case 'delete':
		wp_delete_user($user_ID, $reassign = 'novalue');
		break;
	case 'decline':
		die("Nothing to do for declined status");		
		break;
	default:
		die("Mode is missing or invalid");
		break;
}
print "Success: ".$user_ID." mode=".$f['mode'];
//print_r($f);
function mres($string) {
	return mysql_real_escape_string($string);
}
function make_password() {	
	return substr( md5( uniqid( microtime() ) ), 0, 7);
}
?>